from google.appengine.api import taskqueue


class PushQueue:

    def __init__(self, name, url):
        self._url = url
        self._queue = taskqueue.Queue(name)

    def add(self, params, method="POST"):
        task = taskqueue.Task(
            url=self._url,
            params=params,
            method=method,
            name=params.get("taskName")
        )
        try:
            self._queue.add(task)

        except (taskqueue.TombstonedTaskError, taskqueue.TaskAlreadyExistsError):
            pass

    def addAll(self, arrayOrParams, method="POST", transactional=False):
        tasks = [
            taskqueue.Task(url=self._url, params=params, method=method, name=params.get("taskName"))
            for params in arrayOrParams
        ]
        try:
            self._queue.add(tasks, transactional)

        except (taskqueue.TombstonedTaskError, taskqueue.TaskAlreadyExistsError):
            pass
